/**
 * This class is generated by jOOQ
 */
package com.flamesgroup.storage.jooq.tables;


import com.flamesgroup.storage.jooq.Keys;
import com.flamesgroup.storage.jooq.Public;
import com.flamesgroup.storage.jooq.tables.records.ScriptsCommonsRecord;

import java.util.Arrays;
import java.util.List;

import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.UniqueKey;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class ScriptsCommons extends TableImpl<ScriptsCommonsRecord> {

	private static final long serialVersionUID = 1340504554;

	/**
	 * The reference instance of <code>public.scripts_commons</code>
	 */
	public static final ScriptsCommons SCRIPTS_COMMONS = new ScriptsCommons();

	/**
	 * The class holding records for this type
	 */
	@Override
	public Class<ScriptsCommonsRecord> getRecordType() {
		return ScriptsCommonsRecord.class;
	}

	/**
	 * The column <code>public.scripts_commons.id</code>.
	 */
	public final TableField<ScriptsCommonsRecord, Long> ID = createField("id", org.jooq.impl.SQLDataType.BIGINT.nullable(false).defaulted(true), this, "");

	/**
	 * The column <code>public.scripts_commons.name</code>.
	 */
	public final TableField<ScriptsCommonsRecord, String> NAME = createField("name", org.jooq.impl.SQLDataType.CLOB.nullable(false), this, "");

	/**
	 * The column <code>public.scripts_commons.value</code>.
	 */
	public final TableField<ScriptsCommonsRecord, byte[]> VALUE = createField("value", org.jooq.impl.SQLDataType.BLOB, this, "");

	/**
	 * The column <code>public.scripts_commons.sim_group_id</code>.
	 */
	public final TableField<ScriptsCommonsRecord, Long> SIM_GROUP_ID = createField("sim_group_id", org.jooq.impl.SQLDataType.BIGINT.nullable(false), this, "");

	/**
	 * Create a <code>public.scripts_commons</code> table reference
	 */
	public ScriptsCommons() {
		this("scripts_commons", null);
	}

	/**
	 * Create an aliased <code>public.scripts_commons</code> table reference
	 */
	public ScriptsCommons(String alias) {
		this(alias, SCRIPTS_COMMONS);
	}

	private ScriptsCommons(String alias, Table<ScriptsCommonsRecord> aliased) {
		this(alias, aliased, null);
	}

	private ScriptsCommons(String alias, Table<ScriptsCommonsRecord> aliased, Field<?>[] parameters) {
		super(alias, Public.PUBLIC, aliased, parameters, "");
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public Identity<ScriptsCommonsRecord, Long> getIdentity() {
		return Keys.IDENTITY_SCRIPTS_COMMONS;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public UniqueKey<ScriptsCommonsRecord> getPrimaryKey() {
		return Keys.SCRIPTS_COMMONS_PKEY;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<UniqueKey<ScriptsCommonsRecord>> getKeys() {
		return Arrays.<UniqueKey<ScriptsCommonsRecord>>asList(Keys.SCRIPTS_COMMONS_PKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public List<ForeignKey<ScriptsCommonsRecord, ?>> getReferences() {
		return Arrays.<ForeignKey<ScriptsCommonsRecord, ?>>asList(Keys.SCRIPTS_COMMONS__SCRIPTS_COMMONS_SIM_GROUP_ID_FKEY);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public ScriptsCommons as(String alias) {
		return new ScriptsCommons(alias, this);
	}

	/**
	 * Rename this table
	 */
	public ScriptsCommons rename(String name) {
		return new ScriptsCommons(name, null);
	}
}
